﻿using System;
using System.Collections.Generic;
using System.Linq;
using SpCop.Core.Model;
using SpCop.Model;

namespace SpCop
{
    public abstract class ElementRuleBase : RuleBase
    {
        private readonly Predicate<Element> _elementFilter;

        protected ElementRuleBase() : this(a => true)
        {
        }

        protected ElementRuleBase(Predicate<Element> elementFilter)
        {
            _elementFilter = elementFilter;
        }

        public override void Visit(Feature item)
        {
            VisitCollection(item.Elements.Where(a => _elementFilter(a)), Visit);
        }

        public override IList<Problem> Check(Package package)
        {
            var problems = base.Check(package);
            VisitCollection(Package.Features, Visit);
            return problems;
        }

        public override void Visit(Element item)
        {
            VisitElement(Package, item.Feature, item);
        }

        protected abstract void VisitElement(Package package, Feature feature, Element item);
    }
}